VERSION 5.00
Object = "{E5121320-399E-11D0-B72C-080009D93142}#4.6#0"; "itole.ocx"
Begin VB.Form Form1 
   Caption         =   "X64 Sap interface"
   ClientHeight    =   5880
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   8205
   LinkTopic       =   "Form1"
   ScaleHeight     =   5880
   ScaleWidth      =   8205
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Interval        =   100
      Left            =   3960
      Top             =   5400
   End
   Begin VB.CommandButton Command1 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Check Connection"
      Height          =   375
      Left            =   0
      Style           =   1  'Graphical
      TabIndex        =   2
      Top             =   5400
      Width           =   2175
   End
   Begin VB.TextBox Text1 
      Height          =   5055
      Left            =   120
      MultiLine       =   -1  'True
      TabIndex        =   0
      Top             =   240
      Width           =   8055
   End
   Begin SapAutoGuiOcx.SapEvent Sap 
      Left            =   1680
      Top             =   3360
      _Version        =   262150
      _ExtentX        =   661
      _ExtentY        =   450
      _StockProps     =   0
   End
   Begin VB.Label Label2 
      Caption         =   "Report"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   0
      Width           =   615
   End
   Begin VB.Menu Rs232 
      Caption         =   "Rs 232 Settings"
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Dim G_Conferir(100) As String
Dim G_Servicos(100) As String
Dim G_Quantidade(100) As String
Dim G_Horas(100) As String
Dim G_error(100) As String
Dim terminal As String
Dim portaserie As Integer
Dim BaudRate As Integer

Private Sub Command1_Click()
    Command1.BackColor = &HC0C0C0
    CheckConnection
End Sub

Private Function ShowError(id As Integer) As Boolean
ShowError = False

Close_unexpected_windows (id)

If Len(Trim(G_error(id))) > 0 Then
    ok = Sap.SendKey(vbKeyReturn)
    ok = Sap.SendKey(vbKeyReturn)
    ShowError = True
End If

If (Sap.Message Like "E:*") Or (Sap.Message Like "W:*") Then
    MyDebug (Sap.Message)
    st = Sap.Message
    If st Like "E: A administrao de status no permite confirmao" Then
        st = "E:Operao j         confirmada"
    End If
    If st Like "E: Operao-marco*" Then
        st = "E:Confirmar operao  anterior"
    End If
    
    st = LimpaAcentos(st + Space(80))
    G_error(id) = st
    
    ok = Sap.SendKey(vbKeyReturn)
    ok = Sap.SendKey(vbKeyReturn)
    ShowError = True
End If
End Function

Private Sub Myerror(st As String, id As Integer)
    MyDebug (Sap.Title)
    MyDebug ("SAP ERROR ! Nao encontra " + st)
    G_error(id) = "SAP ERROR !         Nao encontra " + st
End Sub

Private Sub Close_unexpected_windows(id As String)
        
        If Sap.Title Like "Processam*" Then
            ln = Sap.FindByValue("No", 0, SapAnyType, SapHere)
            ok = Sap.SetControlSelected(ln, True)
            ok = Sap.SendKey(vbKeyReturn)
            MyDebug "Erro Status"
            G_error(id) = "Erro de Status"
        End If
        
        If Sap.Title Like "Informa*" Then
            MyDebug ("INFORMACAO")
            ok = Sap.SendKey(vbKeyReturn)
        End If
        
        If Sap.Title Like "Erro na deter*" Then
            MyDebug ("Erro na determinao")
            ok = Sap.SendKey(vbKeyReturn)
        End If
        
        If Sap.Title Like "Consulta*" Then
            MyDebug ("Consulta")
            ok = Sap.SendKey(vbKeyReturn)
        End If
        
        If Sap.Title Like "Mensagens*" Then
            MyDebug ("Mensagens")
            ok = Sap.SendKey(vbKeyReturn)
        End If
        
        If Sap.Title Like "Informao" Then
            ok = Sap.SendKey(vbKeyReturn)
        End If

End Sub

Private Sub do_screen_conferir(id As Integer)
        
        MyDebug ("Confirmao: " + G_Conferir(id))
        
        ln_confirmacao = Sap.FindByField("AFRUD-RUECK", 0, SapAnyType)
        If ln_confirmacao < 0 Then
            Myerror "Confirmacao", id
        Else
            ln_confirmacao = ln_confirmacao + 1
            ok = Sap.SetControlValue(ln_confirmacao, Trim(G_Conferir(id)))
            ok = Sap.SendKey(vbKeyReturn)
            MyDebug ("Title after Enter " + Sap.Title)
            
            ln_quantidade = Sap.FindByField("AFRUD-LMNGA", 0, SapAnyType)  ' Quantidade
            If ln_quantidade < 0 Then
                Myerror "Quantidade", id
            Else
                ln_quantidade = ln_quantidade + 1
                
                QuantidadeSap = Val(Sap.Controls(ln_quantidade))
                MyDebug ("Quantidade SAP " + str(QuantidadeSap) + " ")
        
                ln_tipo = Sap.FindByField("AFRUD-AUERU", 0, SapAnyType)
                If ln_tipo < 0 Then
                    Myerror "Tipo", id
                Else
                    ln_tipo = ln_tipo + 1
                    If QuantidadeSap = Val(G_Quantidade(id)) Then
                        MyDebug ("Finalizando confirmao " + Trim(G_Conferir(id)))
                            ok = Sap.SetControlValue(ln_tipo, "X")
'                            ok = Sap.SendKey(vbKeyUp)
                    End If
                    ok = Sap.SetControlValue(ln_confirmacao, Trim(G_Conferir(id)))
                    ok = Sap.SetControlValue(ln_quantidade, Trim(G_Quantidade(id)))
                    ok = Sap.SendKey(vbKeyReturn)
                End If
            End If
        End If
        
        If ShowError(id) Then Exit Sub
        Sap.SendKey (vbKeyF11)
End Sub

Private Sub do_screen_servicos(id As Integer)
    ln_conf = Sap.FindByField("CORUF-RUECK", 0, SapAnyType) + 1
    If ln_conf - 1 > 0 Then
        ok = Sap.SetControlValue(ln_conf, Trim(G_Servicos(id)))
        ok = Sap.SendKey(vbKeyReturn)
        ln_horas = Sap.FindByField("AFRUD-ISMNW_2", 0, SapAnyType) + 1
        If ln_horas > 0 Then
            ok = Sap.SetControlValue(ln_horas, Trim(G_Horas(id)))
            ok = Sap.SendKey(vbKeyReturn)
        End If
    End If
    
    If ShowError(id) Then Exit Sub
    Sap.SendKey (vbKeyF11)
End Sub

Private Function CheckConnection() As Boolean
Dim descricao As String
    CheckConnection = True
    
    If Not Sap.Connected Then
        Command1.BackColor = &HC0C0C0
        Open "c:\SapOvar.txt" For Input As #1
            Line Input #1, descricao
            Line Input #1, mandante
            Line Input #1, utilizador
            Line Input #1, PASSWORD
            Line Input #1, transacao
            last_transacao = transacao
            MyDebug (utilizador + ":" + transacao)
        Close #1
        
        If Not SapConnect(descricao) Then
            MyDebug ("Erro na Ligao")
            CheckConnection = False
            CloseConnection
            Exit Function
        End If
        DoEvents
        
        ct = 0
        Do
            MySleep (1000)
            MyDebug ("Connecting " + str(ct))
            ok = Sap.Logon(mandante, utilizador, PASSWORD, "PT")
            ct = ct + 1
        Loop While (Not ok) And (ct < 10)
        
        MySleep (2000)
        
        If Trim(Sap.Title) <> "SAP Easy Access" And (Not ok) Then
            MyDebug ("Login errado !")
            MyDebug (Sap.Title)
            CheckConnection = False
            CloseConnection
            Exit Function
        End If
        
        MySleep (1000)
        
        DoEvents
        MyDebug ("System On")
        DoEvents
        Sap.Transaction (transacao)
        MyDebug ("Title after " + transacao + " " + Sap.Title)
        Command1.BackColor = &HFF00&
    End If
End Function

Private Sub CloseConnection()
    If Sap.Connected Then
'        Sap.Logoff
'        Sap.Quit
    End If
    MyDebug ("System Down")
    Command1.BackColor = &HFF&
End Sub

Private Sub Form_Load()
    portaserie = Val(GetSetting("SAP", "BOOT", "COMPORT", "1"))
    BaudRate = Val(GetSetting("SAP", "BOOT", "BAUDRATE", "19200"))
    If InitializeComm(portaserie, BaudRate) = 0 Then
        MsgBox "Error! Base not found !!!!"
    End If
End Sub

Private Sub MyDebug(st As String)
    st = terminal + "->" + str(Now) + " : " + st + Space(80)
    st = Left(Trim(st), 120)
    st1 = ""
    For x = 1 To Len(st)
        If Asc(Mid(st, x, 1)) < 32 Then
            st1 = st1 + " "
        Else
            st1 = st1 + Mid(st, x, 1)
        End If
    Next
    Text1.Text = st1 + Chr(13) + Chr(10) + Text1.Text
    DoEvents
End Sub

Private Sub Form_Unload(Cancel As Integer)
    TerminateComm portaserie
    CloseConnection
End Sub


Public Function SapConnect(Description As String) As Boolean
    Dim nflags As Long
    n = 0
    Do
        n = n + 1
        setting = SapGetProfileString("Description", "Item" + Trim(str(n)))
    Loop While setting <> "" And Not (setting Like Description + "*")
    SapConnect = False
    
    If setting = "" Then
        MyDebug (Description + " , perfil invalido!")
        Exit Function
    End If
    
    sOrigin = SapGetProfileString("Origin", "Item" + Trim(str(n)))
    sserver = SapGetProfileString("Server", "Item" + Trim(str(n)))
    sMsSysName = SapGetProfileString("MsSysName", "Item" + Trim(str(n)))
    sRouter = SapGetProfileString("Router", "Item" + Trim(str(n)))
    sDatabase = SapGetProfileString("Database", "Item" + Trim(str(n)))
    sMsSrvName = SapGetProfileString("MSSrvName", "Item" + Trim(str(n)))
    
    nflags = SapGuiActiveX + SapGuiFront
    Select Case sOrigin
    Case "USEREDIT"
        MyDebug (sserver + "," + sDatabase)
        SapConnect = Sap.Connect(sserver, sDatabase, nflags)
    Case "MS_SEL_GROUPS"
        MyDebug (sMsSysName + "," + sMsSrvName + "," + sserver)
        SapConnect = Sap.NewGroupConnection(sMsSysName, sMsSrvName, sRouter, sserver, nflags)
    End Select
End Function

Public Function SapGetProfileString(ByVal sApp As String, ByVal sKey As String) As String
    Dim sTemp1 As String
    
    sTemp1 = Space(255)
    GetPrivateProfileString sApp, sKey, "", sTemp1, 255, "saplogon.ini"
    sTemp1 = Trim$(sTemp1)
    
    If Right$(sTemp1, 1) = Chr$(0) Then
        SapGetProfileString = Left$(sTemp1, Len(sTemp1) - 1)
    Else
        SapGetProfileString = sTemp1
    End If
        
End Function


Public Function MySleep(miliseconds As Double) As Integer
    x = Timer
    Do
        DoEvents
    Loop While x + (miliseconds / 1000) > Timer

End Function

Private Sub correct_virgulas(id As Long)
Dim st1 As String
    For n = 1 To Len(G_Horas(id))
        If Mid(G_Horas(id), n, 1) = "." Then
            st1 = st1 + ","
        Else
            st1 = st1 + Mid(G_Horas(id), n, 1)
        End If
    Next
    G_Horas(id) = st1
End Sub

Private Sub ReceiveScreen(TerminalId As String, ScrName As String)
    terminal = TerminalId
    T_RefreshScreen TerminalId, ScrName
    DoScreen ScrName, (Val(Right(TerminalId, 2)))

    Select Case ScrName
    Case "Conferir":
        If last_transacao <> "co11n" Then
                Sap.Transaction ("co11n")
        End If
        do_screen_conferir (Val(Right(TerminalId, 2)))
        last_transacao = "co11n"
        
    Case "Servicos":
        If last_transacao <> "IW41" Then
                Sap.Transaction ("IW41")
        End If
        do_screen_servicos (Val(Right(TerminalId, 2)))
        last_transacao = "IW41"
        correct_virgulas (Val(Right(TerminalId, 2)))
    End Select

End Sub

Private Sub AskScreen(TerminalId As String, ScrName As String)
    terminal = TerminalId

    Select Case ScrName
    
    Case "Check_Conferir":
        T_InitScreen TerminalId, ScrName, scr_flag_execute + scr_flag_auto_destroy, 0, 0
        DoScreen ScrName, (Val(Right(TerminalId, 2)))
        T_SendScreen
    
    Case "Check_Servicos":
        T_InitScreen TerminalId, ScrName, scr_flag_execute + scr_flag_auto_destroy, 0, 0
        DoScreen ScrName, (Val(Right(TerminalId, 2)))
        T_SendScreen
        
    
    Case "Conferir":
        G_Conferir(Val(Right(TerminalId, 2))) = Chr(0) + Space(10)
        G_Quantidade(Val(Right(TerminalId, 2))) = Chr(0) + Space(10)
    
        T_InitScreen TerminalId, ScrName, scr_flag_execute, 0, 0
        DoScreen ScrName, (Val(Right(TerminalId, 2)))
        T_SendScreen
    
    Case "Servicos":
        G_Servicos(Val(Right(TerminalId, 2))) = Chr(0) + Space(10)
        G_Horas(Val(Right(TerminalId, 2))) = Chr(0) + Space(10)
    
        T_InitScreen TerminalId, ScrName, scr_flag_execute, 0, 0
        DoScreen ScrName, (Val(Right(TerminalId, 2)))
        T_SendScreen
    
    Case "START":
        If CheckConnection = False Then
            ScrName = "Login Error"
        End If
    
        T_InitScreen TerminalId, ScrName, scr_flag_execute, 0, 0
        DoScreen ScrName, (Val(Right(TerminalId, 2)))
        T_SendScreen
    
    Case Else
    
        T_InitScreen TerminalId, ScrName, scr_flag_execute, 0, 0
        DoScreen ScrName, (Val(Right(TerminalId, 2)))
        T_SendScreen
    End Select
End Sub

Private Sub DoScreen(ScrName As String, id As Integer)

Select Case ScrName
    Case "START":
        
        T_Cls
        T_PrintInverse "IPE"
        T_NewLine
        T_NewLine
        T_Say "Ficha de trabalho"
        T_GetLink "Conferir", 0, 0
        T_NewLine
        T_Say "Ordem de Servico"
        T_GetLink "Servicos", 0, 0
        T_NewLine
        T_Read
        T_GotoScreen "START"

    Case "Login Error":
        T_Cls
        T_PrintInverse "ERROR"
        T_NewLine
        T_NewLine
        T_PrintString "Login Error..."
        T_WaitChar
        T_GotoScreen "START"

    Case "Check_Conferir"
        If Len(Trim(G_error(id))) > 0 Then
            T_Cls
            T_PrintInverse "ERROR"
            T_NewLine
            T_NewLine
            T_PrintString Mid(G_error(id), 1, 20)
            T_NewLine
            T_PrintString Mid(G_error(id), 21, 20)
            T_NewLine
            T_PrintString Mid(G_error(id), 41, 20)
            T_NewLine
            T_PrintString Mid(G_error(id), 61, 20)
            T_NewLine
            T_WaitChar
            G_error(id) = ""

        End If
        T_GotoScreen "Conferir"

    Case "Check_Servicos"
        If Len(Trim(G_error(id))) > 0 Then
            T_Cls
            T_PrintInverse "ERROR"
            T_NewLine
            T_NewLine
            T_PrintString Mid(G_error(id), 1, 20)
            T_NewLine
            T_PrintString Mid(G_error(id), 21, 20)
            T_NewLine
            T_PrintString Mid(G_error(id), 41, 20)
            T_NewLine
            T_PrintString Mid(G_error(id), 61, 20)
            T_NewLine
            T_WaitChar
            G_error(id) = ""
        End If
        T_GotoScreen "Servicos"

    Case "Conferir":
        
        T_OnEscapeGotoScreen "START"
        T_Cls
        T_PrintInverse "IPE"
        T_NewLine
        T_PrintString ("Ficha de trabalho")
        T_NewLine
        T_NewLine
        T_Say ("Confirm.  ")
        T_GetText G_Conferir(id), 10, GetText_flag_Barcode
        T_NewLine
    
        T_Say ("Quantid.  ")
        T_GetText G_Quantidade(id), 10, GetText_flag_ExitEnter
        T_NewLine
        
        T_Say ("Ok")
        T_GetCheckEnter
        T_NewLine
        T_Read
        
        T_SendScreenToPc "Conferir", scr_flag_update_pc_now + scr_flag_restore_fields_after_send
        T_GotoScreen "Check_Conferir"
    
    Case "Servicos":
                
        T_OnEscapeGotoScreen "START"
        T_Cls
        T_PrintInverse "IPE"
        T_NewLine
        T_PrintString ("Ordem de servico")
        T_NewLine
        T_NewLine
        T_Say ("Confirm.  ")
        T_GetText G_Servicos(id), 10, GetText_flag_Barcode
        T_NewLine
    
        T_Say ("Horas     ")
        T_GetText G_Horas(id), 10, GetText_flag_ExitEnter
        T_NewLine
        
        T_Say ("Ok")
        T_GetCheckEnter
        T_NewLine
        
        T_Read
    
        T_SendScreenToPc "Servicos", scr_flag_update_pc_now + scr_flag_restore_fields_after_send
        T_GotoScreen "Check_Servicos"
        
    
End Select

End Sub

Private Sub Rs232_Click()
    Form2.Show
End Sub

Private Sub Timer1_Timer()
Dim TerminalId As String
Dim ScreenName As String
Dim DataType As Byte
Dim RawDataSize As Long
Dim RawData As String

    TerminalId = Space(8)
    ScreenName = Space(50)
    RawData = Space(2000)
    
    Do While T_CheckIfReceiveData(TerminalId, ScreenName, DataType, RawDataSize, RawData)
        Debug.Print "Receive CheckIf" + ScreenName + " " + TerminalId
        ScreenName = Trim(ScreenName)
        If Len(ScreenName) > 0 Then
             ScreenName = Left(ScreenName, Len(ScreenName) - 1)
        End If
        Select Case DataType
            Case data_type_reset
'                Reset (TerminalId)
            Case data_type_send_screen_zipped
                ReceiveScreen TerminalId, ScreenName
            Case data_type_send_screen_unzipped
                ReceiveScreen TerminalId, ScreenName
            Case data_type_ask_screen
                AskScreen TerminalId, ScreenName
        End Select
        ScreenName = Space(50)
    Loop
        
End Sub

Private Function LimpaAcentos(st As String)
    For n = 1 To Len(st)
        If Asc(Mid(st, n, 1)) >= 128 Then
            If Mid(st, n, 1) = "" Then Mid(st, n, 1) = "e"
            If Mid(st, n, 1) = "" Then Mid(st, n, 1) = "e"
            If Mid(st, n, 1) = "" Then Mid(st, n, 1) = "E"
            If Mid(st, n, 1) = "" Then Mid(st, n, 1) = "i"
            If Mid(st, n, 1) = "" Then Mid(st, n, 1) = "c"
            If Mid(st, n, 1) = "" Then Mid(st, n, 1) = "C"
            If Mid(st, n, 1) = "" Then Mid(st, n, 1) = "o"
            If Mid(st, n, 1) = "" Then Mid(st, n, 1) = "o"
            If Mid(st, n, 1) = "" Then Mid(st, n, 1) = "o"
            If Mid(st, n, 1) = "" Then Mid(st, n, 1) = "O"
            If Mid(st, n, 1) = "" Then Mid(st, n, 1) = "A"
            If Mid(st, n, 1) = "" Then Mid(st, n, 1) = "A"
            If Mid(st, n, 1) = "" Then Mid(st, n, 1) = "A"
            If Mid(st, n, 1) = "" Then Mid(st, n, 1) = "a"
            If Mid(st, n, 1) = "" Then Mid(st, n, 1) = "a"
            If Mid(st, n, 1) = "" Then Mid(st, n, 1) = "a"
            If Mid(st, n, 1) = "" Then Mid(st, n, 1) = "a"
            If Mid(st, n, 1) = "" Then Mid(st, n, 1) = "A"
            If Mid(st, n, 1) = "" Then Mid(st, n, 1) = "E"
            If Mid(st, n, 1) = "" Then Mid(st, n, 1) = "U"
            If Mid(st, n, 1) = "" Then Mid(st, n, 1) = "I"
            If Mid(st, n, 1) = "" Then Mid(st, n, 1) = "O"
            If Mid(st, n, 1) = "" Then Mid(st, n, 1) = "O"
            If Mid(st, n, 1) = "" Then Mid(st, n, 1) = "A"
            If Mid(st, n, 1) = "" Then Mid(st, n, 1) = "."
            If Mid(st, n, 1) = "" Then Mid(st, n, 1) = "."
        End If
    Next
    LimpaAcentos = st
End Function

