Attribute VB_Name = "Module1"
Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long



Public Declare Function InitializeComm Lib "RioCom" (ByVal ComPort As Long, ByVal BaudRate As Long) As Long
Public Declare Sub TerminateComm Lib "RioCom" (ByVal ComPort As Long)

Public Declare Sub BackSendMessage Lib "RioCom" (ByVal DestinationId As String, ByVal data As String, ByVal size As Long)
Public Declare Sub BackGetEvent Lib "RioCom" (ByVal FunctionAddress As Long)

Public Declare Function Reset_Message Lib "RioCom" (ByVal DestinationId As String) As Long
Public Declare Function Send_Message Lib "RioCom" (ByVal DestinationId As String, ByVal data As String, ByVal size As Long) As Long
Public Declare Function Get_Message Lib "RioCom" (ByRef BlockPtr As Long, ByVal MaxSize As Long, ByVal TimeoutMiliS As Long, ByVal ID As String) As Long

Public Declare Function GetStringFromPtr Lib "RioCom" (ByVal st As String, ByVal Pt As Long, ByVal size As Long) As String

Public Declare Function T_InitScreen Lib "RioCom" (ByVal TerminalId As String, ByVal ScreenName As String, ByVal ScreenFlags As Long, ByVal ScreenCursor As Long, ByVal ScreenValidate As Long) As Long
Public Declare Function T_CheckIfReceiveData Lib "RioCom" (ByVal TerminalId As String, ByVal ScreenName As String, ByRef DataType As Byte, ByRef RawDataSize As Long, ByVal RawData As String) As Long
Public Declare Function T_RefreshScreen Lib "RioCom" (ByVal TerminalId As String, ByVal ScreenName As String) As Long
Public Declare Function T_SendScreen Lib "RioCom" () As Long

Public Declare Function T_PrintLarge Lib "RioCom" (ByVal txt As String) As Long
Public Declare Function T_Cls Lib "RioCom" () As Long

Public Declare Function T_GetText Lib "RioCom" (ByVal txt As String, ByVal size As Long, ByVal flags As Long) As Long
Public Declare Function T_GetTextTemplate Lib "RioCom" (ByVal txt As String, ByVal template As String, ByVal flags As Long) As Long

Public Declare Function T_PutTextOnList Lib "RioCom" (ByVal txt As String, ByVal Value As Long, ByVal FastKey As Byte) As Long
Public Declare Function T_GetTextFromList Lib "RioCom" (ByRef Number As Long, ByVal size As Long, ByVal ScreenName As String) As Long
Public Declare Function T_GetLink Lib "RioCom" (ByVal ScreenName As String, ByVal Value As Long, ByVal FastKey As Byte) As Long
Public Declare Function T_GotoScreen Lib "RioCom" (ByVal ScreenName As String) As Long
Public Declare Function T_SetLink Lib "RioCom" (ByVal ScreenName As String) As Long
Public Declare Function T_GetOption Lib "RioCom" (ByRef Position As Long, ByVal List As String, ByVal LenList As Long, ByVal Max As Long) As Long
Public Declare Function T_GetOptionGotoScreen Lib "RioCom" (ByRef Position As Long, ByVal List As String, ByVal LenList As Long, ByVal Max As Long, ByVal ScreenList As String) As Long

Public Declare Function T_OnEscapeGotoScreen Lib "RioCom" (ByVal ScreenName As String) As Long
Public Declare Function T_OnF1GotoScreen Lib "RioCom" (ByVal ScreenName As String) As Long
Public Declare Function T_OnF2GotoScreen Lib "RioCom" (ByVal ScreenName As String) As Long
Public Declare Function T_OnF3GotoScreen Lib "RioCom" (ByVal ScreenName As String) As Long
Public Declare Function T_OnF4GotoScreen Lib "RioCom" (ByVal ScreenName As String) As Long
Public Declare Function T_OnF5GotoScreen Lib "RioCom" (ByVal ScreenName As String) As Long
Public Declare Function T_OnF6GotoScreen Lib "RioCom" (ByVal ScreenName As String) As Long
Public Declare Function T_OnF7GotoScreen Lib "RioCom" (ByVal ScreenName As String) As Long
Public Declare Function T_OnF8GotoScreen Lib "RioCom" (ByVal ScreenName As String) As Long
Public Declare Function T_SetFunctionKeys Lib "RioCom" (ByVal Keys As String) As Long
Public Declare Function T_SetLargeFunctionKeys Lib "RioCom" (ByVal Keys As String, ByVal bytes_Key As Byte) As Long


Public Declare Function T_GetCheckEnter Lib "RioCom" () As Long
Public Declare Function T_SetGetTextFromListFlags Lib "RioCom" (ByVal flags As Long) As Long

Public Declare Function T_Say Lib "RioCom" (ByVal txt As String) As Long
Public Declare Function T_NoSay Lib "RioCom" (ByVal size As Byte) As Long
Public Declare Function T_Read Lib "RioCom" () As Long
Public Declare Function T_NewLine Lib "RioCom" () As Long
Public Declare Function T_Beep Lib "RioCom" (ByVal duration As Long, ByVal periodo As Long) As Long
Public Declare Function T_WaitChar Lib "RioCom" () As Byte
Public Declare Function T_Delay Lib "RioCom" (ByVal miliseconds As Long) As Long
Public Declare Function T_ChangeUpsideDown Lib "RioCom" (ByVal flag As Byte) As Long
Public Declare Function T_PrintInverse Lib "RioCom" (ByVal txt As String) As Long
Public Declare Function T_SendScreenToPc Lib "RioCom" (ByVal ScreenName As String, ByVal scr_flag As Long) As Long
Public Declare Function T_SetSeconds Lib "RioCom" (ByVal seconds As Long) As Long
Public Declare Function T_PrintString Lib "RioCom" (ByVal txt As String) As Long
Public Declare Function T_PrintCom Lib "RioCom" (ByVal txt As String, ByVal size As Long) As Long
Public Declare Function T_PrintSprite Lib "RioCom" (ByVal FileName As String, ByVal x As Byte, ByVal y As Byte) As Long

Public Declare Function T_SetLcdLightPower Lib "RioCom" (ByVal state As Byte) As Long
Public Declare Function T_StartRepeat Lib "RioCom" (ByRef times As Long) As Long
Public Declare Function T_EndRepeat Lib "RioCom" () As Long
Public Declare Function T_GetRepeat Lib "RioCom" (ByVal times As Byte) As Long
Public Declare Function T_GetNumerical Lib "RioCom" (ByRef Number As Long, ByVal size As Long, ByVal flags As Long) As Long

Public Declare Function T_ReserveVariable Lib "RioCom" (ByVal VariableName As String) As Long
Public Declare Function T_WriteVariable Lib "RioCom" (ByVal VariableName As String, ByVal Valor As Long) As Long
Public Declare Function T_ReadVariable Lib "RioCom" (ByVal VariableName As String) As Long
Public Declare Function T_AddVariable Lib "RioCom" (ByVal VariableNameDest As String, ByVal VariableNameSrc1 As String, ByVal VariableNameSrc2 As String) As Long
Public Declare Function T_GetVariable Lib "RioCom" (ByVal VariableName As String, ByVal size As Long, ByVal flags As Long) As Long

Public Declare Function T_ReserveStrVariable Lib "RioCom" (ByVal VariableName As String) As Long
Public Declare Function T_WriteStrVariable Lib "RioCom" (ByVal VariableName As String, ByVal str As String, ByVal size As Long) As Long
Public Declare Function T_ReadStrVariable Lib "RioCom" (ByVal VariableName As String, ByVal str As String, ByVal size As Long) As Long
'Public Declare Function T_AddStrVariable Lib "RioCom" (ByVal VariableNameDest As String, ByVal VariableNameSrc1 As String, ByVal VariableNameSrc2 As String) As Long
Public Declare Function T_GetStrVariable Lib "RioCom" (ByVal VariableName As String, ByVal size As Long, ByVal flags As Long) As Long

Public Declare Function T_IfVar1EqVar2Goto Lib "RioCom" (ByVal VariableName1 As String, ByVal VariableName2 As String, ByVal ScreenName As String) As Long
Public Declare Function T_IfVar1NotEqVar2Goto Lib "RioCom" (ByVal VariableName1 As String, ByVal VariableName2 As String, ByVal ScreenName As String) As Long
Public Declare Function T_IfVar1LessVar2Goto Lib "RioCom" (ByVal VariableName1 As String, ByVal VariableName2 As String, ByVal ScreenName As String) As Long
Public Declare Function T_IfVar1GreaterVar2Goto Lib "RioCom" (ByVal VariableName1 As String, ByVal VariableName2 As String, ByVal ScreenName As String) As Long

Public Declare Function T_MulVariable Lib "RioCom" (ByVal VariableNameDest As String, ByVal VariableNameSrc1 As String, ByVal VariableNameSrc2 As String) As Long
Public Declare Function T_DivVariable Lib "RioCom" (ByVal VariableNameDest As String, ByVal VariableNameSrc1 As String, ByVal VariableNameSrc2 As String) As Long

Public Declare Function T_CreateListIndex Lib "RioCom" (ByVal ListName As String, ByVal size As Long) As Long
Public Declare Function T_ActivateListIndex Lib "RioCom" (ByVal ListName As String) As Long
Public Declare Function T_DesactivateListIndex Lib "RioCom" () As Long
Public Declare Function T_DestroyListIndex Lib "RioCom" (ByVal ListName As String) As Long

Public Declare Function T_SendScreenToNull Lib "RioCom" (ByVal ScreenName As String, ByVal scr_flag As Long) As Long

Public Declare Function T_ResetComunications Lib "RioCom" () As Long
Public Declare Function T_HardReset Lib "RioCom" () As Long
Public Declare Function T_SaveScreens Lib "RioCom" (ByVal FileName As String) As Long
Public Declare Function T_LoadScreens Lib "RioCom" (ByVal FileName As String) As Long
Public Declare Function T_LoadComunicationStatus Lib "RioCom" (ByVal FileName As String) As Long
Public Declare Function T_SaveComunicationStatus Lib "RioCom" (ByVal FileName As String) As Long


Public Declare Function T_EmptyScreenBuffers Lib "RioCom" () As Long
Public Declare Function T_SetDisplay Lib "RioCom" (ByVal DisplayNumber As Byte) As Long
Public Declare Function T_ShowDisplay Lib "RioCom" () As Long
Public Declare Function T_RunCCode Lib "RioCom" (ByVal path As String, ByVal FileName As String) As Long
Public Declare Function T_ChangeScreenFormat Lib "RioCom" (ByVal ScreenFormat As Long) As Long
Public Declare Function T_GetExitNow Lib "RioCom" () As Long
Public Declare Function T_GetTextFromList2 Lib "RioCom" (ByRef Number As Long, ByVal size As Long, ByVal ScreenName As String, ByVal ListName As String, ByVal flags As Long) As Long



Public Const GetText_flag_Protected = -1
Public Const GetText_flag_AutoExit = -2                         ' After last char
Public Const GetText_flag_Password = -4
Public Const GetText_flag_Number = -8
Public Const GetText_flag_ExitEnter = -16
Public Const GetText_flag_ExitAlways = -32
Public Const GetText_flag_Barcode = -64
Public Const GetText_flag_NotUnderline = -128
Public Const GetText_flag_Link = -256
Public Const GetText_flag_NewText = -512
Public Const GetText_flag_NumberRightAligned = -1024
Public Const GetText_flag_DontShowZero = -2048
Public Const GetText_flag_ForceFunctionKeys = -4096
Public Const GetText_flag_NoFunctionKeys = -8192
Public Const GetText_flag_AutoexitfieldON = -16384              ' On last char
Public Const GetText_flag_OnlyExitIfTemplateOK = -32768


Public Const scr_flag_execute = 1
Public Const scr_flag_changed = 2
Public Const scr_flag_update_pc_if_possible = 4
Public Const scr_flag_update_pc_now = 8
Public Const scr_flag_update_pc_later = 16
Public Const scr_flag_auto_destroy = 32
Public Const scr_flag_ask_pc_answer = 64
Public Const scr_flag_restore_fields_after_send = 256
Public Const scr_flag_dont_stop = 512
Public Const scr_flag_keep_cursor_positon = 1024



Public Const data_type_send_screen_zipped = 1
Public Const data_type_ask_screen = 2
Public Const data_type_reset = 3
Public Const data_type_send_screen_unzipped = 4
Public Const data_type_send_raw_data = 7




